;;;; cl-scopes/test-steps - testing for the scopes-steps system.

(defpackage :scopes/test-steps
  (:use :common-lisp)
  (:local-nicknames (:config :scopes/config)
                    (:steps :scopes/steps)
                    (:util :scopes/util)
                    (:t :scopes/testing))
  (:export #:run #:user #:password)
  (:import-from :scopes/testing #:deftest #:==))

(in-package :scopes/test-steps)

(defvar *config* nil)

(defclass test-suite (t:test-suite)
  ((receiver :initform (make-instance 'steps:service :name :test-rcvr)
             :reader receiver)))

(defun run ()
  (let ((*config* nil)
        (t:*test-suite* (make-instance 'test-suite :name "steps")))
    (load (t:test-path "config-steps" "etc"))
    (test-send)
    (t:show-result)))

(t:deftest test-send ()
  (let ((rcvr (receiver t:*test-suite*))
        (msg nil))
    (== (steps:name rcvr) :test-rcvr)
    (steps:send rcvr msg)
    ))
